﻿<template>
    <form class="form"
          novalidate
          @submit.prevent="handleSubmit"
          enctype="multipart/form-data">

        <FormInput v-model="member.email"
                   type="email"
                   name="email"
                   :ref="addFormInputRef"
                   :label="t('member.form.email')"
                   @validated="handleValidation"
                   @blured="handleEmailBlur"/>

        <FormRow>
            <FormInput v-model="member.firstName"
                       type="text"
                       name="first-name"
                       :ref="addFormInputRef"
                       :label="t('member.form.firstName')"
                       @validated="handleValidation" />
            <FormInput v-model="member.lastName"
                       type="text"
                       name="last-name"
                       :ref="addFormInputRef"
                       :label="t('member.form.lastName')"
                       @validated="handleValidation" />
        </FormRow>

        <FormRow v-if="!isUpdate">
            <FormInput v-model="member.password"
                       type="password"
                       name="password1"
                       :ref="addFormInputRef"
                       :label="t('member.form.password')"
                       @validated="handleValidation" />
            <FormInput v-model="passwd2"
                       type="password"
                       name="password2"
                       :ref="addFormInputRef"
                       :label="t('member.form.password2')"
                       @validated="handleValidation" />
        </FormRow>

        <FormFiles v-model="member.avatar"
                   name="avatar"
                   :ref="addFormInputRef"
                   :label="t('member.form.avatar')"
                   :possiblesTypes="['image/png', 'image/jpg', 'image/jpeg', 'image/webp']"
                   :default-selected-files="member.avatar != null ? [member.avatar] : []"
                   can-delete
                   @on-default-selected-files-change="onSavedImageChange($event)"
                   @change="onImageChange($event)"
                   @validated="handleValidation" />
        <slot name="image"></slot>

        <button v-if="!isUpdate" class="form__submit btn btn--fullscreen" type="submit">
            {{ t("global.add") }}
        </button>
        <button v-else class="form__submit btn btn--fullscreen" type="submit">
            {{ t("global.save") }}
        </button>
    </form>
</template>

<script lang="ts" setup>
    import FormInput from "@/components/forms/FormInput.vue";
    import FormRow from "@/components/forms/FormRow.vue";
    import FormFiles from "@/components/forms/FormFiles.vue";
    import { ref } from "vue";
    import { useI18n } from "vue3-i18n";
    import { Status } from "@/validation";
    import { notifyError } from "@/notify"
    import { Member } from "@/types/entities";
    import { useMemberService } from "@/inversify.config";

    const { t } = useI18n();
    const memberService = useMemberService();

    // eslint-disable-next-line no-undef
    const props = defineProps<{
        member?: Member
    }>()

    // eslint-disable-next-line
    const emit = defineEmits<{
        (event: "formSubmit", member: Member): void
    }>()

    const member = ref<Member>(props.member ?? {})
    const passwd2 = ref<string>("")
    const formInputs = ref<any[]>([])
    const inputValidationStatuses: any = {}
    const isUpdate = props.member !== undefined;

    function addFormInputRef(ref: typeof FormInput) {
        if (!formInputs.value.includes(ref) && ref)
            formInputs.value.push(ref)
    }

    async function onImageChange(event: any) {
        const file = event?.target?.files[0];
        if (file) member.value.avatar = file as File
    }

    async function onSavedImageChange(url: string) {
        member.value.savedAvatarImage = url
    }

    async function handleValidation(name: string, validationStatus: Status) {
        inputValidationStatuses[name] = validationStatus.valid
    }

    async function handleSubmit() {
        formInputs.value.forEach((x: typeof FormInput) => x.validateInput())
        if (Object.values(inputValidationStatuses).some(x => x === false)) {
            notifyError(t('global.formErrorNotification'))
            return
        }

        if (!isUpdate && member.value.password !== passwd2.value) {
            notifyError(t('validation.member.add.passwordMissmatch'))
            // TODO: Mettre les champs en rouge
            return
        }

        emit("formSubmit", member.value)
    }

    async function handleEmailBlur(value: string) {
        if (!isUpdate) {
            const emailAlreadyExists = await memberService.doesEmailAlreadyExists(value);
            if (emailAlreadyExists) {
                notifyError(t('validation.member.add.emailAlreadyExists'))
                // TODO: Mettre le champ en rouge
            }
        }
    }
</script>